% Final Problem 1 - Spring 2019   
% Coded by NFR on 5.4.2019
%
% Part (a)
% Write system of equations        [see the pts for this on sub-function]
[tp,yp] = ode45(@SYS,[0 36],[10 1])             % 2pt correct ODE solver use
plot(tp,yp(:,1),tp,yp(:,2))                     % 3pt plot w/ correct labels + legend
legend('Rabbits','Foxes')
ylabel('# of Animals')
xlabel('Time (months)')
% Part (b)
% From inspection of the plot, the minima occur betoween times ~0 and 5 
% as well as times ~ 5 to 15.  Looking at vector of yp(:,2) I see that
% these will fall in these ranges:
[~,ind1] = min(yp(1:50,2));
[~,ind2] = min(yp(51:100,2)); 
% NOTE, ind2 is 20, which actually is 20 + 50, as we started at 51)
ind2 = ind2 + 50;
% Check by putting this marks on the plot            % 2pts find minima
                                                  %NOTE: there can be many 
                                                  % ways to find these.  Be
                                                  % flexible on method
hold on
plot(tp(ind1),yp(ind1,2),'k+',tp(ind2),yp(ind2,2),'k+')    % 1pt - plot the minima points
hold off
% Now we need to integrate (numerically) between these points
FoxMonths = trapz(tp(ind1:ind2,1),yp(ind1:ind2,2))        % 2pt - solve the integral

% Part (c)
ko = .1;
disp('k needs to be smaller than this to keep rabbits below 100:')
ksolve = fzero(@odeopt,ko)                         % 1 pt - run solver on subfunction set up below
[tp,yp] = ode45(@(t,y) SYS2(t,y,ksolve),[0 36],[10 1]); 
figure                                              % 1 pt - solve ODE once more
plot(tp,yp(:,1),tp,yp(:,2))                         % 1 pt - plot w/ labels
legend('Rabbits','Foxes')
ylabel('# of Animals')
xlabel('Time (months)')





function dy = SYS(t,y)                % 1 pt change of variable
% t = t                               % 2 pt setup of ODE equations
% y(1) = x, rabbits
% y(2) = y, foxes
%
h = 1.5;
p = 0.5;
k = 0.2;
b = 0.2;
dy = [h*y(1)-k*y(1)*y(2);...
    b*k*y(1)*y(2)-p*y(2)];
end

function E = odeopt(k)
% We need to pass k parameter to ode45, this is in the ode45 help file:
%{
A = 1;                             % 2 pt - setting up optimization 
                                   % sub-function , again, this COULD be
                                   done manually.
B = 2;
tspan = [0 5];
y0 = [0 0.01];
[t,y] = ode45(@(t,y) odefcn(t,y,A,B), tspan, y0);
%}
[~,yp] = ode45(@(t,y) SYS2(t,y,k),[0 36],[10 1]);
MaxRabbit = max(yp(:,1));
E = MaxRabbit-100;
end

function dy = SYS2(t,y,k)          % 2 pt setting up method to pass k parameter
                                   % NOTE: this could also be done using
                                   % (manual) iterative guessing.  If they
                                   % do this, and get to the answer that is
                                   % a valid (albeit slow) method.
% t = t
% y(1) = x, rabbits
% y(2) = y, foxes
%
h = 1.5;
p = 0.5;
%
b = 0.2;
dy = [h*y(1)-k*y(1)*y(2);...
    b*k*y(1)*y(2)-p*y(2)];
end