% Final problem 2
% Coded by NFR on 5.4.2019
%
clc
close all
% Part (a)
[tp,yp] = ode45(@SYS,[0 20],[0 1]);     % 2 pt calling ode solver with correct inputs
plot(tp,yp(:,1))                        % 2 pt plotting output (with labels)
xlabel('Time (s)')
ylabel('Position (cm)')
% Part (b)
FitFunc = fittype('Ao*exp(-lam*t)*sin(B*t)','independent','t','dependent','x');   % 2 pt set up fit
c = fit(tp,yp(:,1),FitFunc,'StartPoint',[1 1 1]);                                 % 2 pt Perform fit
figure
plot(c,tp,yp(:,1))                                                                % 2 pt plot with fit
disp('These are the fit parameters:')                   % 2 pt, correct fit parameters
Ao = c.Ao                                               %     Ao = 0.2801
Period = 2*pi()/c.B                                     %     Period = 1.7595
Lambda = c.lam                                          %     Lambda = 0.5
% Part (c)
% Embed part (a) and part (b) content in subfuntion to use fsolve
go = 1;
Vo = fsolve(@optfunc,go);                                     % 1 pt - correct use of fsolve and 
disp('This initial velocity will set max amplitude to 0.15:')
Vo                                                             %1 pt - correct answer

function E = optfunc(g)              % 1 pt - correct subfunction passing slope parameter
[tp,yp] = ode45(@SYS,[0 20],[0 g]);
FitFunc = fittype('Ao*exp(-lam*t)*sin(B*t)','independent','t','dependent','x');
c = fit(tp,yp(:,1),FitFunc,'StartPoint',[1 1 1]);      % 1 pt - fitting the solution
Ao = c.Ao;
E = 0.15-Ao;                                           % 1 pt - checking fit parameter

end

function dy = SYS(t,y)               % Separation of variables 1 pt
                                     % Setting up two equations 2 pt
% t(1) = t;
% y(1) = x;
% y(2) = h;
%
dy = [y(2);...
    -y(2)-13*y(1)];
end